/* StreamReader.c generated by valac 0.56.18, the Vala compiler
 * generated from StreamReader.vala, do not modify */

/* ParserStream.vala
 *
 * Copyright (C) 2019  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include "gxml/gxml.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include "gxml.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GXML_STREAM_READER_0_PROPERTY,
	GXML_STREAM_READER_STREAM_PROPERTY,
	GXML_STREAM_READER_CANCELLABLE_PROPERTY,
	GXML_STREAM_READER_DOCUMENT_PROPERTY,
	GXML_STREAM_READER_NUM_PROPERTIES
};
static GParamSpec* gxml_stream_reader_properties[GXML_STREAM_READER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _GXmlStreamReaderPrivate {
	guint8* buf;
	gint buf_length1;
	gint _buf_size_;
	GeeHashMap* root_collections;
	GDataInputStream* _stream;
	GXmlDomDocument* _document;
	gboolean start;
	GCancellable* _cancellable;
};

static gint GXmlStreamReader_private_offset;
static gpointer gxml_stream_reader_parent_class = NULL;

static void gxml_stream_reader_internal_read (GXmlStreamReader* self,
                                       GError** error);
static inline gboolean gxml_stream_reader_read_byte (GXmlStreamReader* self,
                                       GError** error);
static inline gchar* gxml_stream_reader_read_upto (GXmlStreamReader* self,
                                     const gchar* str,
                                     GError** error);
static inline gchar gxml_stream_reader_cur_char (GXmlStreamReader* self);
static inline guint8 gxml_stream_reader_cur_byte (GXmlStreamReader* self);
static GXmlElement* gxml_stream_reader_read_root_element (GXmlStreamReader* self,
                                                   GError** error);
static gboolean gxml_stream_reader_is_space (GXmlStreamReader* self,
                                      gchar c);
static void gxml_stream_reader_parse_xml_dec (GXmlStreamReader* self,
                                       GError** error);
static void gxml_stream_reader_read_text_node (GXmlStreamReader* self,
                                        GError** error);
static void gxml_stream_reader_parse_pi_dec (GXmlStreamReader* self,
                                      GError** error);
static void gxml_stream_reader_parse_comment_dec (GXmlStreamReader* self,
                                           GError** error);
static GXmlElement* gxml_stream_reader_read_element (GXmlStreamReader* self,
                                              gboolean children,
                                              GXmlElement* parent,
                                              GError** error);
static void _g_param_spec_unref0_ (gpointer var);
static inline void _g_list_free__g_param_spec_unref0_ (GList* self);
static void gxml_stream_reader_finalize (GObject * obj);
static GType gxml_stream_reader_get_type_once (void);
static void _vala_gxml_stream_reader_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_gxml_stream_reader_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GQuark
gxml_stream_reader_error_quark (void)
{
	return g_quark_from_static_string ("gxml-stream-reader-error-quark");
}

static GType
gxml_stream_reader_error_get_type_once (void)
{
	static const GEnumValue values[] = {{GXML_STREAM_READER_ERROR_INVALID_DOCUMENT_ERROR, "GXML_STREAM_READER_ERROR_INVALID_DOCUMENT_ERROR", "invalid-document-error"}, {GXML_STREAM_READER_ERROR_DATA_READ_ERROR, "GXML_STREAM_READER_ERROR_DATA_READ_ERROR", "data-read-error"}, {0, NULL, NULL}};
	GType gxml_stream_reader_error_type_id;
	gxml_stream_reader_error_type_id = g_enum_register_static ("GXmlStreamReaderError", values);
	return gxml_stream_reader_error_type_id;
}

GType
gxml_stream_reader_error_get_type (void)
{
	static volatile gsize gxml_stream_reader_error_type_id__once = 0;
	if (g_once_init_enter (&gxml_stream_reader_error_type_id__once)) {
		GType gxml_stream_reader_error_type_id;
		gxml_stream_reader_error_type_id = gxml_stream_reader_error_get_type_once ();
		g_once_init_leave (&gxml_stream_reader_error_type_id__once, gxml_stream_reader_error_type_id);
	}
	return gxml_stream_reader_error_type_id__once;
}

static inline gpointer
gxml_stream_reader_get_instance_private (GXmlStreamReader* self)
{
	return G_STRUCT_MEMBER_P (self, GXmlStreamReader_private_offset);
}

GDataInputStream*
gxml_stream_reader_get_stream (GXmlStreamReader* self)
{
	GDataInputStream* result;
	GDataInputStream* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_stream;
	result = _tmp0_;
	return result;
}

GCancellable*
gxml_stream_reader_get_cancellable (GXmlStreamReader* self)
{
	GCancellable* result;
	GCancellable* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_cancellable;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
gxml_stream_reader_set_cancellable (GXmlStreamReader* self,
                                    GCancellable* value)
{
	GCancellable* old_value;
	g_return_if_fail (self != NULL);
	old_value = gxml_stream_reader_get_cancellable (self);
	if (old_value != value) {
		GCancellable* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_cancellable);
		self->priv->_cancellable = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gxml_stream_reader_properties[GXML_STREAM_READER_CANCELLABLE_PROPERTY]);
	}
}

GXmlDomDocument*
gxml_stream_reader_get_document (GXmlStreamReader* self)
{
	GXmlDomDocument* result;
	GXmlDomDocument* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_document;
	result = _tmp0_;
	return result;
}

/**
   * Creates a new {@link StreamReader} object.
   */
GXmlStreamReader*
gxml_stream_reader_construct (GType object_type,
                              GInputStream* istream)
{
	GXmlStreamReader * self = NULL;
	GDataInputStream* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	guint8* _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (istream != NULL, NULL);
	self = (GXmlStreamReader*) g_object_new (object_type, NULL);
	_tmp0_ = g_data_input_stream_new (istream);
	_g_object_unref0 (self->priv->_stream);
	self->priv->_stream = _tmp0_;
	_tmp1_ = self->priv->buf;
	_tmp1__length1 = self->priv->buf_length1;
	_tmp1_[0] = (guint8) '\0';
	_tmp2_ = self->priv->buf;
	_tmp2__length1 = self->priv->buf_length1;
	_tmp2_[1] = (guint8) '\0';
	return self;
}

GXmlStreamReader*
gxml_stream_reader_new (GInputStream* istream)
{
	return gxml_stream_reader_construct (GXML_TYPE_STREAM_READER, istream);
}

/**
   * Creates a new {@link StreamReader} object and
   * initialize {@link document} with given document
   */
GXmlStreamReader*
gxml_stream_reader_construct_for_document (GType object_type,
                                           GInputStream* istream,
                                           GXmlDomDocument* document)
{
	GXmlStreamReader * self = NULL;
	GDataInputStream* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	guint8* _tmp2_;
	gint _tmp2__length1;
	GXmlDomDocument* _tmp3_;
	g_return_val_if_fail (istream != NULL, NULL);
	g_return_val_if_fail (document != NULL, NULL);
	self = (GXmlStreamReader*) g_object_new (object_type, NULL);
	_tmp0_ = g_data_input_stream_new (istream);
	_g_object_unref0 (self->priv->_stream);
	self->priv->_stream = _tmp0_;
	_tmp1_ = self->priv->buf;
	_tmp1__length1 = self->priv->buf_length1;
	_tmp1_[0] = (guint8) '\0';
	_tmp2_ = self->priv->buf;
	_tmp2__length1 = self->priv->buf_length1;
	_tmp2_[1] = (guint8) '\0';
	_tmp3_ = _g_object_ref0 (document);
	_g_object_unref0 (self->priv->_document);
	self->priv->_document = _tmp3_;
	return self;
}

GXmlStreamReader*
gxml_stream_reader_new_for_document (GInputStream* istream,
                                     GXmlDomDocument* document)
{
	return gxml_stream_reader_construct_for_document (GXML_TYPE_STREAM_READER, istream, document);
}

/**
   * Reads the content of a stream to {@link document}.
   *
   * If {@link document} was not set, treates a new {@link DomDocument}
   *
   * Returns: {@link document}'s value
   */
GXmlDomDocument*
gxml_stream_reader_read (GXmlStreamReader* self,
                         GError** error)
{
	GXmlDomDocument* _tmp0_;
	GXmlDomDocument* _tmp2_;
	GXmlDomDocument* _tmp3_;
	GError* _inner_error0_ = NULL;
	GXmlDomDocument* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_document;
	if (_tmp0_ == NULL) {
		GXmlDocument* _tmp1_;
		_tmp1_ = gxml_document_new ();
		_g_object_unref0 (self->priv->_document);
		self->priv->_document = (GXmlDomDocument*) _tmp1_;
	}
	gxml_stream_reader_internal_read (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp2_ = self->priv->_document;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	return result;
}

/**
   * Use a {@link DomDocument} to initialize {@link document}
   * and parse its contents to
   */
void
gxml_stream_reader_read_document (GXmlStreamReader* self,
                                  GXmlDomDocument* doc,
                                  GError** error)
{
	GXmlDomDocument* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (doc != NULL);
	_tmp0_ = _g_object_ref0 (doc);
	_g_object_unref0 (self->priv->_document);
	self->priv->_document = _tmp0_;
	gxml_stream_reader_internal_read (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
}

static inline gboolean
gxml_stream_reader_read_byte (GXmlStreamReader* self,
                              GError** error)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		guint8 _tmp0_ = 0U;
		GDataInputStream* _tmp1_;
		GDataInputStream* _tmp2_;
		GCancellable* _tmp3_;
		guint8* _tmp4_;
		gint _tmp4__length1;
		_tmp1_ = gxml_stream_reader_get_stream (self);
		_tmp2_ = _tmp1_;
		_tmp3_ = self->priv->_cancellable;
		_tmp0_ = g_data_input_stream_read_byte (_tmp2_, _tmp3_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp4_ = self->priv->buf;
		_tmp4__length1 = self->priv->buf_length1;
		_tmp4_[0] = _tmp0_;
	}
	goto __finally0;
	__catch0_g_error:
	{
		guint8* _tmp5_;
		gint _tmp5__length1;
		g_clear_error (&_inner_error0_);
		_tmp5_ = self->priv->buf;
		_tmp5__length1 = self->priv->buf_length1;
		_tmp5_[0] = (guint8) '\0';
		result = FALSE;
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp6_ = FALSE;
		g_propagate_error (error, _inner_error0_);
		return _tmp6_;
	}
	result = TRUE;
	return result;
}

static inline gchar*
gxml_stream_reader_read_upto (GXmlStreamReader* self,
                              const gchar* str,
                              GError** error)
{
	gchar* bstr = NULL;
	GDataInputStream* _tmp0_;
	GDataInputStream* _tmp1_;
	GCancellable* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (str != NULL, NULL);
	_tmp0_ = gxml_stream_reader_get_stream (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->_cancellable;
	_tmp3_ = g_data_input_stream_read_upto (_tmp1_, str, (gssize) -1, NULL, _tmp2_, &_inner_error0_);
	bstr = _tmp3_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	result = bstr;
	return result;
}

static inline gchar
gxml_stream_reader_cur_char (GXmlStreamReader* self)
{
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint8 _tmp1_;
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = self->priv->buf;
	_tmp0__length1 = self->priv->buf_length1;
	_tmp1_ = _tmp0_[0];
	result = (gchar) _tmp1_;
	return result;
}

static inline guint8
gxml_stream_reader_cur_byte (GXmlStreamReader* self)
{
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint8 _tmp1_;
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->buf;
	_tmp0__length1 = self->priv->buf_length1;
	_tmp1_ = _tmp0_[0];
	result = _tmp1_;
	return result;
}

static void
gxml_stream_reader_internal_read (GXmlStreamReader* self,
                                  GError** error)
{
	GXmlElement* _tmp0_;
	GXmlElement* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	self->priv->start = TRUE;
	gxml_stream_reader_parse_doc_nodes (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
	_tmp0_ = gxml_stream_reader_read_root_element (self, &_inner_error0_);
	_tmp1_ = _tmp0_;
	_g_object_unref0 (_tmp1_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
	_tmp2_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
	if (!_tmp2_) {
		return;
	}
	gxml_stream_reader_parse_doc_nodes (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
}

void
gxml_stream_reader_parse_doc_nodes (GXmlStreamReader* self,
                                    GError** error)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
	if (!_tmp0_) {
		return;
	}
	while (TRUE) {
		gboolean _tmp2_ = FALSE;
		gboolean _tmp4_ = FALSE;
		if (gxml_stream_reader_cur_char (self) != '<') {
			GError* _tmp1_;
			_tmp1_ = g_error_new_literal (GXML_STREAM_READER_ERROR, GXML_STREAM_READER_ERROR_INVALID_DOCUMENT_ERROR, _ ("Invalid document: expected '<' character"));
			_inner_error0_ = _tmp1_;
			g_propagate_error (error, _inner_error0_);
			return;
		}
		_tmp2_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			return;
		}
		if (!_tmp2_) {
			return;
		}
		if (gxml_stream_reader_is_space (self, gxml_stream_reader_cur_char (self))) {
			GError* _tmp3_;
			_tmp3_ = g_error_new_literal (GXML_STREAM_READER_ERROR, GXML_STREAM_READER_ERROR_INVALID_DOCUMENT_ERROR, _ ("Invalid document: unexpected space character before node's name"));
			_inner_error0_ = _tmp3_;
			g_propagate_error (error, _inner_error0_);
			return;
		}
		if (gxml_stream_reader_cur_char (self) != '?') {
			_tmp4_ = gxml_stream_reader_cur_char (self) != '!';
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			return;
		}
		if (gxml_stream_reader_cur_char (self) == '?') {
			if (self->priv->start) {
				gxml_stream_reader_parse_xml_dec (self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					return;
				}
				self->priv->start = FALSE;
				gxml_stream_reader_read_text_node (self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					return;
				}
				continue;
			} else {
				gxml_stream_reader_parse_pi_dec (self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					return;
				}
				gxml_stream_reader_read_text_node (self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					return;
				}
				continue;
			}
		} else {
			if (gxml_stream_reader_cur_char (self) == '!') {
				gxml_stream_reader_parse_comment_dec (self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					return;
				}
				gxml_stream_reader_read_text_node (self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					return;
				}
				g_message ("StreamReader.vala:175: Stoped at: %c", (gint) gxml_stream_reader_cur_char (self));
				continue;
			}
		}
	}
}

static GXmlElement*
gxml_stream_reader_read_root_element (GXmlStreamReader* self,
                                      GError** error)
{
	GXmlElement* _tmp0_ = NULL;
	GXmlElement* _tmp1_;
	GXmlElement* _tmp2_;
	GError* _inner_error0_ = NULL;
	GXmlElement* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = gxml_stream_reader_read_element (self, TRUE, NULL, &_inner_error0_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp2_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp2_;
	_g_object_unref0 (_tmp0_);
	return result;
}

static gpointer
_g_param_spec_ref0 (gpointer self)
{
	return self ? g_param_spec_ref (self) : NULL;
}

static void
_g_param_spec_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL));
}

static inline void
_g_list_free__g_param_spec_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_param_spec_unref0_);
}

static GXmlElement*
gxml_stream_reader_read_element (GXmlStreamReader* self,
                                 gboolean children,
                                 GXmlElement* parent,
                                 GError** error)
{
	GXmlElement* e = NULL;
	GMemoryOutputStream* buffer = NULL;
	GMemoryOutputStream* _tmp2_;
	GDataOutputStream* dbuf = NULL;
	GMemoryOutputStream* _tmp3_;
	GDataOutputStream* _tmp4_;
	GMemoryOutputStream* oname_buf = NULL;
	guint8* _tmp5_;
	GReallocFunc _tmp6_;
	GDestroyNotify _tmp7_;
	GMemoryOutputStream* _tmp8_;
	GDataOutputStream* name_buf = NULL;
	GMemoryOutputStream* _tmp9_;
	GDataOutputStream* _tmp10_;
	GDataOutputStream* _tmp11_;
	GDataOutputStream* _tmp12_;
	GDataOutputStream* _tmp13_;
	gboolean _tmp14_ = FALSE;
	GDataOutputStream* _tmp16_;
	gboolean is_empty = FALSE;
	GDataOutputStream* _tmp27_;
	GCancellable* _tmp28_;
	GXmlDomDocument* _tmp29_;
	GXmlDomDocument* _tmp30_;
	GXmlDomElement* _tmp31_;
	GXmlDomElement* _tmp32_;
	GXmlDomElement* _tmp33_;
	gboolean _tmp34_;
	GXmlElement* _tmp38_;
	gboolean _tmp57_ = FALSE;
	GXmlDomDocument* _tmp58_;
	GXmlDomDocument* _tmp59_;
	GXmlDomElement* _tmp60_;
	GXmlDomElement* _tmp61_;
	GXmlDomElement* _tmp62_;
	GXmlElement* _tmp63_;
	gboolean _tmp64_;
	GXmlElement* _tmp132_;
	GMemoryOutputStream* _tmp133_;
	GError* _inner_error0_ = NULL;
	GXmlElement* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (parent != NULL) {
		if (!GXML_IS_OBJECT (parent)) {
			const gchar* _tmp0_;
			GError* _tmp1_;
			_tmp0_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) parent));
			_tmp1_ = g_error_new (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Parent '%s' is not implementing GXml.Object interface"), _tmp0_);
			_inner_error0_ = _tmp1_;
			g_propagate_error (error, _inner_error0_);
			return NULL;
		}
	}
	e = NULL;
	_tmp2_ = (GMemoryOutputStream*) g_memory_output_stream_new_resizable ();
	buffer = _tmp2_;
	_tmp3_ = buffer;
	_tmp4_ = g_data_output_stream_new ((GOutputStream*) _tmp3_);
	dbuf = _tmp4_;
	_tmp5_ = g_new0 (guint8, 1024);
	_tmp6_ = g_realloc;
	_tmp7_ = g_free;
	_tmp8_ = (GMemoryOutputStream*) g_memory_output_stream_new (_tmp5_, 1024, _tmp6_, _tmp7_);
	oname_buf = _tmp8_;
	_tmp9_ = oname_buf;
	_tmp10_ = g_data_output_stream_new ((GOutputStream*) _tmp9_);
	name_buf = _tmp10_;
	_tmp11_ = dbuf;
	g_data_output_stream_put_byte (_tmp11_, (guint8) '<', NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (name_buf);
		_g_object_unref0 (oname_buf);
		_g_object_unref0 (dbuf);
		_g_object_unref0 (buffer);
		_g_object_unref0 (e);
		return NULL;
	}
	_tmp12_ = dbuf;
	g_data_output_stream_put_byte (_tmp12_, gxml_stream_reader_cur_byte (self), NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (name_buf);
		_g_object_unref0 (oname_buf);
		_g_object_unref0 (dbuf);
		_g_object_unref0 (buffer);
		_g_object_unref0 (e);
		return NULL;
	}
	_tmp13_ = name_buf;
	g_data_output_stream_put_byte (_tmp13_, gxml_stream_reader_cur_byte (self), NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (name_buf);
		_g_object_unref0 (oname_buf);
		_g_object_unref0 (dbuf);
		_g_object_unref0 (buffer);
		_g_object_unref0 (e);
		return NULL;
	}
	_tmp14_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (name_buf);
		_g_object_unref0 (oname_buf);
		_g_object_unref0 (dbuf);
		_g_object_unref0 (buffer);
		_g_object_unref0 (e);
		return NULL;
	}
	if (!_tmp14_) {
		GError* _tmp15_;
		_tmp15_ = g_error_new_literal (GXML_STREAM_READER_ERROR, GXML_STREAM_READER_ERROR_DATA_READ_ERROR, _ ("Can't continue parsing due to error reading data"));
		_inner_error0_ = _tmp15_;
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (name_buf);
		_g_object_unref0 (oname_buf);
		_g_object_unref0 (dbuf);
		_g_object_unref0 (buffer);
		_g_object_unref0 (e);
		return NULL;
	}
	_tmp16_ = dbuf;
	g_data_output_stream_put_byte (_tmp16_, gxml_stream_reader_cur_byte (self), NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (name_buf);
		_g_object_unref0 (oname_buf);
		_g_object_unref0 (dbuf);
		_g_object_unref0 (buffer);
		_g_object_unref0 (e);
		return NULL;
	}
	is_empty = FALSE;
	while (TRUE) {
		GDataOutputStream* _tmp23_;
		GCancellable* _tmp24_;
		gboolean _tmp25_ = FALSE;
		GDataOutputStream* _tmp26_;
		if (!(gxml_stream_reader_cur_char (self) != '>')) {
			break;
		}
		if (gxml_stream_reader_is_space (self, gxml_stream_reader_cur_char (self))) {
			break;
		}
		if (gxml_stream_reader_cur_char (self) == '/') {
			GDataOutputStream* _tmp17_;
			gchar* rest = NULL;
			gchar* _tmp18_;
			GDataOutputStream* _tmp19_;
			const gchar* _tmp20_;
			gboolean _tmp21_ = FALSE;
			GDataOutputStream* _tmp22_;
			_tmp17_ = dbuf;
			g_data_output_stream_put_byte (_tmp17_, (guint8) gxml_stream_reader_cur_char (self), NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (name_buf);
				_g_object_unref0 (oname_buf);
				_g_object_unref0 (dbuf);
				_g_object_unref0 (buffer);
				_g_object_unref0 (e);
				return NULL;
			}
			_tmp18_ = gxml_stream_reader_read_upto (self, ">", &_inner_error0_);
			rest = _tmp18_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (name_buf);
				_g_object_unref0 (oname_buf);
				_g_object_unref0 (dbuf);
				_g_object_unref0 (buffer);
				_g_object_unref0 (e);
				return NULL;
			}
			_tmp19_ = dbuf;
			_tmp20_ = rest;
			g_data_output_stream_put_string (_tmp19_, _tmp20_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (rest);
				_g_object_unref0 (name_buf);
				_g_object_unref0 (oname_buf);
				_g_object_unref0 (dbuf);
				_g_object_unref0 (buffer);
				_g_object_unref0 (e);
				return NULL;
			}
			_tmp21_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (rest);
				_g_object_unref0 (name_buf);
				_g_object_unref0 (oname_buf);
				_g_object_unref0 (dbuf);
				_g_object_unref0 (buffer);
				_g_object_unref0 (e);
				return NULL;
			}
			if (!_tmp21_) {
				_g_free0 (rest);
				break;
			}
			_tmp22_ = dbuf;
			g_data_output_stream_put_byte (_tmp22_, gxml_stream_reader_cur_byte (self), NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (rest);
				_g_object_unref0 (name_buf);
				_g_object_unref0 (oname_buf);
				_g_object_unref0 (dbuf);
				_g_object_unref0 (buffer);
				_g_object_unref0 (e);
				return NULL;
			}
			is_empty = TRUE;
			_g_free0 (rest);
			break;
		}
		_tmp23_ = name_buf;
		_tmp24_ = self->priv->_cancellable;
		g_data_output_stream_put_byte (_tmp23_, gxml_stream_reader_cur_byte (self), _tmp24_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (name_buf);
			_g_object_unref0 (oname_buf);
			_g_object_unref0 (dbuf);
			_g_object_unref0 (buffer);
			_g_object_unref0 (e);
			return NULL;
		}
		_tmp25_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (name_buf);
			_g_object_unref0 (oname_buf);
			_g_object_unref0 (dbuf);
			_g_object_unref0 (buffer);
			_g_object_unref0 (e);
			return NULL;
		}
		if (!_tmp25_) {
			break;
		}
		_tmp26_ = dbuf;
		g_data_output_stream_put_byte (_tmp26_, gxml_stream_reader_cur_byte (self), NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (name_buf);
			_g_object_unref0 (oname_buf);
			_g_object_unref0 (dbuf);
			_g_object_unref0 (buffer);
			_g_object_unref0 (e);
			return NULL;
		}
	}
	_tmp27_ = name_buf;
	_tmp28_ = self->priv->_cancellable;
	g_data_output_stream_put_byte (_tmp27_, (guint8) '\0', _tmp28_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (name_buf);
		_g_object_unref0 (oname_buf);
		_g_object_unref0 (dbuf);
		_g_object_unref0 (buffer);
		_g_object_unref0 (e);
		return NULL;
	}
	_tmp29_ = gxml_stream_reader_get_document (self);
	_tmp30_ = _tmp29_;
	_tmp31_ = gxml_dom_document_get_document_element (_tmp30_);
	_tmp32_ = _tmp31_;
	_tmp33_ = _tmp32_;
	_tmp34_ = _tmp33_ == NULL;
	_g_object_unref0 (_tmp33_);
	if (_tmp34_) {
		GXmlDomDocument* _tmp35_;
		GXmlDomDocument* _tmp36_;
		GXmlElement* _tmp37_;
		_tmp35_ = gxml_stream_reader_get_document (self);
		_tmp36_ = _tmp35_;
		_tmp37_ = gxml_document_search_root_element_property (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, GXML_TYPE_DOCUMENT, GXmlDocument));
		_g_object_unref0 (e);
		e = _tmp37_;
	}
	_tmp38_ = e;
	if (_tmp38_ == NULL) {
		GXmlDomElement* _tmp39_ = NULL;
		GXmlDomDocument* _tmp40_;
		GXmlDomDocument* _tmp41_;
		GMemoryOutputStream* _tmp42_;
		guint8* _tmp43_;
		GXmlDomElement* _tmp44_;
		GXmlElement* _tmp45_;
		GXmlDomDocument* _tmp46_;
		GXmlDomDocument* _tmp47_;
		GXmlDomElement* _tmp48_;
		GXmlDomElement* _tmp49_;
		GXmlDomElement* _tmp50_;
		gboolean _tmp51_;
		_tmp40_ = gxml_stream_reader_get_document (self);
		_tmp41_ = _tmp40_;
		_tmp42_ = oname_buf;
		_tmp43_ = g_memory_output_stream_get_data (_tmp42_);
		_tmp44_ = gxml_dom_document_create_element (_tmp41_, (const gchar*) _tmp43_, &_inner_error0_);
		_tmp39_ = _tmp44_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (name_buf);
			_g_object_unref0 (oname_buf);
			_g_object_unref0 (dbuf);
			_g_object_unref0 (buffer);
			_g_object_unref0 (e);
			return NULL;
		}
		_tmp45_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GXML_TYPE_ELEMENT, GXmlElement));
		_g_object_unref0 (e);
		e = _tmp45_;
		_tmp46_ = gxml_stream_reader_get_document (self);
		_tmp47_ = _tmp46_;
		_tmp48_ = gxml_dom_document_get_document_element (_tmp47_);
		_tmp49_ = _tmp48_;
		_tmp50_ = _tmp49_;
		_tmp51_ = _tmp50_ == NULL;
		_g_object_unref0 (_tmp50_);
		if (_tmp51_) {
			GXmlDomDocument* _tmp52_;
			GXmlDomDocument* _tmp53_;
			GXmlElement* _tmp54_;
			GXmlDomNode* _tmp55_;
			GXmlDomNode* _tmp56_;
			_tmp52_ = gxml_stream_reader_get_document (self);
			_tmp53_ = _tmp52_;
			_tmp54_ = e;
			_tmp55_ = gxml_dom_node_append_child ((GXmlDomNode*) _tmp53_, (GXmlDomNode*) _tmp54_, &_inner_error0_);
			_tmp56_ = _tmp55_;
			_g_object_unref0 (_tmp56_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (_tmp39_);
				_g_object_unref0 (name_buf);
				_g_object_unref0 (oname_buf);
				_g_object_unref0 (dbuf);
				_g_object_unref0 (buffer);
				_g_object_unref0 (e);
				return NULL;
			}
		}
		_g_object_unref0 (_tmp39_);
	}
	_tmp58_ = gxml_stream_reader_get_document (self);
	_tmp59_ = _tmp58_;
	_tmp60_ = gxml_dom_document_get_document_element (_tmp59_);
	_tmp61_ = _tmp60_;
	_tmp62_ = _tmp61_;
	_tmp63_ = e;
	_tmp64_ = _tmp62_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, GXML_TYPE_DOM_ELEMENT, GXmlDomElement);
	_g_object_unref0 (_tmp62_);
	if (_tmp64_) {
		_tmp57_ = parent == NULL;
	} else {
		_tmp57_ = FALSE;
	}
	if (_tmp57_) {
		GXmlElement* _tmp65_;
		GList* _tmp66_;
		_tmp65_ = e;
		_tmp66_ = gxml_object_get_property_element_list (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, GXML_TYPE_OBJECT, GXmlObject));
		{
			GList* pspec_collection = NULL;
			GList* pspec_it = NULL;
			pspec_collection = _tmp66_;
			for (pspec_it = pspec_collection; pspec_it != NULL; pspec_it = pspec_it->next) {
				GParamSpec* _tmp67_;
				GParamSpec* pspec = NULL;
				_tmp67_ = _g_param_spec_ref0 ((GParamSpec*) pspec_it->data);
				pspec = _tmp67_;
				{
					GParamSpec* _tmp68_;
					GXmlCollection* col = NULL;
					GValue vc = {0};
					GParamSpec* _tmp69_;
					GValue _tmp70_ = {0};
					GXmlElement* _tmp71_;
					GParamSpec* _tmp72_;
					const gchar* _tmp73_;
					GObject* _tmp74_;
					GXmlCollection* _tmp75_;
					GXmlCollection* _tmp76_;
					gboolean _tmp87_ = FALSE;
					GXmlCollection* _tmp88_;
					GType _tmp89_;
					GType _tmp90_;
					gboolean _tmp97_ = FALSE;
					GXmlCollection* _tmp98_;
					const gchar* _tmp99_;
					const gchar* _tmp100_;
					gboolean _tmp107_ = FALSE;
					GXmlCollection* _tmp108_;
					GXmlDomElement* _tmp109_;
					GXmlDomElement* _tmp110_;
					GXmlCollection* _tmp117_;
					GXmlDomElement* _tmp118_;
					GXmlDomElement* _tmp119_;
					GeeHashMap* _tmp125_;
					GXmlCollection* _tmp126_;
					const gchar* _tmp127_;
					const gchar* _tmp128_;
					gchar* _tmp129_;
					gchar* _tmp130_;
					GXmlCollection* _tmp131_;
					_tmp68_ = pspec;
					if (!g_type_is_a (_tmp68_->value_type, GXML_TYPE_COLLECTION)) {
						_g_param_spec_unref0 (pspec);
						continue;
					}
					_tmp69_ = pspec;
					g_value_init (&_tmp70_, _tmp69_->value_type);
					vc = _tmp70_;
					_tmp71_ = e;
					_tmp72_ = pspec;
					_tmp73_ = _tmp72_->name;
					g_object_get_property ((GObject*) _tmp71_, _tmp73_, &vc);
					_tmp74_ = g_value_get_object (&vc);
					_tmp75_ = _g_object_ref0 (GXML_IS_COLLECTION (_tmp74_) ? ((GXmlCollection*) _tmp74_) : NULL);
					_g_object_unref0 (col);
					col = _tmp75_;
					_tmp76_ = col;
					if (_tmp76_ == NULL) {
						GParamSpec* _tmp77_;
						GXmlElement* _tmp78_;
						GObject* _tmp79_;
						GObject* _tmp80_;
						GXmlCollection* _tmp81_;
						GXmlCollection* _tmp82_;
						GXmlElement* _tmp83_;
						GParamSpec* _tmp84_;
						const gchar* _tmp85_;
						GValue _tmp86_;
						_tmp77_ = pspec;
						_tmp78_ = e;
						_tmp79_ = g_object_new (_tmp77_->value_type, "element", _tmp78_, NULL);
						_tmp80_ = G_IS_INITIALLY_UNOWNED (_tmp79_) ? g_object_ref_sink (_tmp79_) : _tmp79_;
						_tmp81_ = GXML_IS_COLLECTION (_tmp80_) ? ((GXmlCollection*) _tmp80_) : NULL;
						if (_tmp81_ == NULL) {
							_g_object_unref0 (_tmp80_);
						}
						_g_object_unref0 (col);
						col = _tmp81_;
						_tmp82_ = col;
						g_value_set_object (&vc, (GObject*) _tmp82_);
						_tmp83_ = e;
						_tmp84_ = pspec;
						_tmp85_ = _tmp84_->name;
						_tmp86_ = vc;
						g_object_set_property ((GObject*) _tmp83_, _tmp85_, &_tmp86_);
					}
					_tmp88_ = col;
					_tmp89_ = gxml_collection_get_items_type (_tmp88_);
					_tmp90_ = _tmp89_;
					if (_tmp90_ == G_TYPE_INVALID) {
						_tmp87_ = TRUE;
					} else {
						GXmlCollection* _tmp91_;
						GType _tmp92_;
						GType _tmp93_;
						_tmp91_ = col;
						_tmp92_ = gxml_collection_get_items_type (_tmp91_);
						_tmp93_ = _tmp92_;
						_tmp87_ = !g_type_is_a (_tmp93_, GXML_TYPE_OBJECT);
					}
					if (_tmp87_) {
						GXmlCollection* _tmp94_;
						const gchar* _tmp95_;
						GError* _tmp96_;
						_tmp94_ = col;
						_tmp95_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp94_));
						_tmp96_ = g_error_new (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Collection '%s' hasn't been constructed properly: items' type property" \
" was not set at construction time or set to invalid type"), _tmp95_);
						_inner_error0_ = _tmp96_;
						g_propagate_error (error, _inner_error0_);
						G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
						_g_object_unref0 (col);
						_g_param_spec_unref0 (pspec);
						(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
						_g_object_unref0 (name_buf);
						_g_object_unref0 (oname_buf);
						_g_object_unref0 (dbuf);
						_g_object_unref0 (buffer);
						_g_object_unref0 (e);
						return NULL;
					}
					_tmp98_ = col;
					_tmp99_ = gxml_collection_get_items_name (_tmp98_);
					_tmp100_ = _tmp99_;
					if (g_strcmp0 (_tmp100_, "") == 0) {
						_tmp97_ = TRUE;
					} else {
						GXmlCollection* _tmp101_;
						const gchar* _tmp102_;
						const gchar* _tmp103_;
						_tmp101_ = col;
						_tmp102_ = gxml_collection_get_items_name (_tmp101_);
						_tmp103_ = _tmp102_;
						_tmp97_ = _tmp103_ == NULL;
					}
					if (_tmp97_) {
						GXmlCollection* _tmp104_;
						const gchar* _tmp105_;
						GError* _tmp106_;
						_tmp104_ = col;
						_tmp105_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp104_));
						_tmp106_ = g_error_new (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Collection '%s' hasn't been constructed properly: items' name property" \
" was not set at construction time"), _tmp105_);
						_inner_error0_ = _tmp106_;
						g_propagate_error (error, _inner_error0_);
						G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
						_g_object_unref0 (col);
						_g_param_spec_unref0 (pspec);
						(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
						_g_object_unref0 (name_buf);
						_g_object_unref0 (oname_buf);
						_g_object_unref0 (dbuf);
						_g_object_unref0 (buffer);
						_g_object_unref0 (e);
						return NULL;
					}
					_tmp108_ = col;
					_tmp109_ = gxml_collection_get_element (_tmp108_);
					_tmp110_ = _tmp109_;
					if (_tmp110_ == NULL) {
						_tmp107_ = TRUE;
					} else {
						GXmlCollection* _tmp111_;
						GXmlDomElement* _tmp112_;
						GXmlDomElement* _tmp113_;
						_tmp111_ = col;
						_tmp112_ = gxml_collection_get_element (_tmp111_);
						_tmp113_ = _tmp112_;
						_tmp107_ = !GXML_IS_OBJECT (_tmp113_);
					}
					if (_tmp107_) {
						GXmlCollection* _tmp114_;
						const gchar* _tmp115_;
						GError* _tmp116_;
						_tmp114_ = col;
						_tmp115_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp114_));
						_tmp116_ = g_error_new (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Collection '%s' hasn't been constructed properly: element property was" \
" not set at construction time"), _tmp115_);
						_inner_error0_ = _tmp116_;
						g_propagate_error (error, _inner_error0_);
						G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
						_g_object_unref0 (col);
						_g_param_spec_unref0 (pspec);
						(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
						_g_object_unref0 (name_buf);
						_g_object_unref0 (oname_buf);
						_g_object_unref0 (dbuf);
						_g_object_unref0 (buffer);
						_g_object_unref0 (e);
						return NULL;
					}
					_tmp117_ = col;
					_tmp118_ = gxml_collection_get_element (_tmp117_);
					_tmp119_ = _tmp118_;
					if (!GXML_IS_OBJECT (_tmp119_)) {
						GXmlCollection* _tmp120_;
						GXmlDomElement* _tmp121_;
						GXmlDomElement* _tmp122_;
						const gchar* _tmp123_;
						GError* _tmp124_;
						_tmp120_ = col;
						_tmp121_ = gxml_collection_get_element (_tmp120_);
						_tmp122_ = _tmp121_;
						_tmp123_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp122_));
						_tmp124_ = g_error_new (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Invalid object of type '%s' doesn't implement GXml.Object interface: c" \
"an't be handled by the collection"), _tmp123_);
						_inner_error0_ = _tmp124_;
						g_propagate_error (error, _inner_error0_);
						G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
						_g_object_unref0 (col);
						_g_param_spec_unref0 (pspec);
						(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
						_g_object_unref0 (name_buf);
						_g_object_unref0 (oname_buf);
						_g_object_unref0 (dbuf);
						_g_object_unref0 (buffer);
						_g_object_unref0 (e);
						return NULL;
					}
					_tmp125_ = self->priv->root_collections;
					_tmp126_ = col;
					_tmp127_ = gxml_collection_get_items_name (_tmp126_);
					_tmp128_ = _tmp127_;
					_tmp129_ = g_utf8_strdown (_tmp128_, (gssize) -1);
					_tmp130_ = _tmp129_;
					_tmp131_ = col;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp125_, _tmp130_, _tmp131_);
					_g_free0 (_tmp130_);
					G_IS_VALUE (&vc) ? (g_value_unset (&vc), NULL) : NULL;
					_g_object_unref0 (col);
					_g_param_spec_unref0 (pspec);
				}
			}
			(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
		}
	}
	_tmp132_ = e;
	_tmp133_ = buffer;
	gxml_element_set_read_buffer (_tmp132_, _tmp133_);
	if (is_empty) {
		result = e;
		_g_object_unref0 (name_buf);
		_g_object_unref0 (oname_buf);
		_g_object_unref0 (dbuf);
		_g_object_unref0 (buffer);
		return result;
	}
	while (TRUE) {
		gboolean _tmp134_ = FALSE;
		_tmp134_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (name_buf);
			_g_object_unref0 (oname_buf);
			_g_object_unref0 (dbuf);
			_g_object_unref0 (buffer);
			_g_object_unref0 (e);
			return NULL;
		}
		if (!_tmp134_) {
			break;
		}
		if (gxml_stream_reader_cur_char (self) == '<') {
			gboolean _tmp135_ = FALSE;
			_tmp135_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (name_buf);
				_g_object_unref0 (oname_buf);
				_g_object_unref0 (dbuf);
				_g_object_unref0 (buffer);
				_g_object_unref0 (e);
				return NULL;
			}
			if (!_tmp135_) {
				break;
			}
			if (gxml_stream_reader_cur_char (self) == '/') {
				GDataOutputStream* _tmp136_;
				GDataOutputStream* _tmp137_;
				gchar* closetag = NULL;
				GDataInputStream* _tmp138_;
				GDataInputStream* _tmp139_;
				GCancellable* _tmp140_;
				gchar* _tmp141_;
				GDataOutputStream* _tmp142_;
				const gchar* _tmp143_;
				gboolean _tmp144_ = FALSE;
				GDataOutputStream* _tmp145_;
				const gchar* _tmp146_;
				GMemoryOutputStream* _tmp147_;
				guint8* _tmp148_;
				_tmp136_ = dbuf;
				g_data_output_stream_put_byte (_tmp136_, (guint8) '<', NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (name_buf);
					_g_object_unref0 (oname_buf);
					_g_object_unref0 (dbuf);
					_g_object_unref0 (buffer);
					_g_object_unref0 (e);
					return NULL;
				}
				_tmp137_ = dbuf;
				g_data_output_stream_put_byte (_tmp137_, gxml_stream_reader_cur_byte (self), NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (name_buf);
					_g_object_unref0 (oname_buf);
					_g_object_unref0 (dbuf);
					_g_object_unref0 (buffer);
					_g_object_unref0 (e);
					return NULL;
				}
				_tmp138_ = gxml_stream_reader_get_stream (self);
				_tmp139_ = _tmp138_;
				_tmp140_ = self->priv->_cancellable;
				_tmp141_ = g_data_input_stream_read_upto (_tmp139_, ">", (gssize) -1, NULL, _tmp140_, &_inner_error0_);
				closetag = _tmp141_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (name_buf);
					_g_object_unref0 (oname_buf);
					_g_object_unref0 (dbuf);
					_g_object_unref0 (buffer);
					_g_object_unref0 (e);
					return NULL;
				}
				_tmp142_ = dbuf;
				_tmp143_ = closetag;
				g_data_output_stream_put_string (_tmp142_, _tmp143_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_free0 (closetag);
					_g_object_unref0 (name_buf);
					_g_object_unref0 (oname_buf);
					_g_object_unref0 (dbuf);
					_g_object_unref0 (buffer);
					_g_object_unref0 (e);
					return NULL;
				}
				_tmp144_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_free0 (closetag);
					_g_object_unref0 (name_buf);
					_g_object_unref0 (oname_buf);
					_g_object_unref0 (dbuf);
					_g_object_unref0 (buffer);
					_g_object_unref0 (e);
					return NULL;
				}
				if (!_tmp144_) {
					_g_free0 (closetag);
					break;
				}
				_tmp145_ = dbuf;
				g_data_output_stream_put_byte (_tmp145_, gxml_stream_reader_cur_byte (self), NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_free0 (closetag);
					_g_object_unref0 (name_buf);
					_g_object_unref0 (oname_buf);
					_g_object_unref0 (dbuf);
					_g_object_unref0 (buffer);
					_g_object_unref0 (e);
					return NULL;
				}
				_tmp146_ = closetag;
				_tmp147_ = oname_buf;
				_tmp148_ = g_memory_output_stream_get_data (_tmp147_);
				if (g_strcmp0 (_tmp146_, (const gchar*) _tmp148_) == 0) {
					result = e;
					_g_free0 (closetag);
					_g_object_unref0 (name_buf);
					_g_object_unref0 (oname_buf);
					_g_object_unref0 (dbuf);
					_g_object_unref0 (buffer);
					return result;
				}
				_g_free0 (closetag);
			} else {
				gboolean _tmp149_ = FALSE;
				if (children) {
					_tmp149_ = parent == NULL;
				} else {
					_tmp149_ = FALSE;
				}
				if (_tmp149_) {
					GXmlElement* ce = NULL;
					GXmlElement* _tmp150_;
					GXmlElement* _tmp151_;
					GXmlCollection* col = NULL;
					GeeHashMap* _tmp152_;
					GXmlElement* _tmp153_;
					gchar* _tmp154_;
					gchar* _tmp155_;
					gchar* _tmp156_;
					gchar* _tmp157_;
					gchar* _tmp158_;
					gpointer _tmp159_;
					GXmlCollection* _tmp160_;
					GXmlCollection* _tmp161_;
					_tmp150_ = e;
					_tmp151_ = gxml_stream_reader_read_element (self, FALSE, _tmp150_, &_inner_error0_);
					ce = _tmp151_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						g_propagate_error (error, _inner_error0_);
						_g_object_unref0 (name_buf);
						_g_object_unref0 (oname_buf);
						_g_object_unref0 (dbuf);
						_g_object_unref0 (buffer);
						_g_object_unref0 (e);
						return NULL;
					}
					_tmp152_ = self->priv->root_collections;
					_tmp153_ = ce;
					_tmp154_ = gxml_dom_element_get_local_name ((GXmlDomElement*) _tmp153_);
					_tmp155_ = _tmp154_;
					_tmp156_ = _tmp155_;
					_tmp157_ = g_utf8_strdown (_tmp156_, (gssize) -1);
					_tmp158_ = _tmp157_;
					_tmp159_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp152_, _tmp158_);
					_tmp160_ = (GXmlCollection*) _tmp159_;
					_g_free0 (_tmp158_);
					_g_free0 (_tmp156_);
					col = _tmp160_;
					_tmp161_ = col;
					if (_tmp161_ != NULL) {
						GXmlElement* cobj = NULL;
						GXmlCollection* _tmp162_;
						GType _tmp163_;
						GType _tmp164_;
						GXmlDomDocument* _tmp165_;
						GXmlDomDocument* _tmp166_;
						GObject* _tmp167_;
						GObject* _tmp168_;
						GXmlElement* _tmp169_;
						GXmlElement* _tmp170_;
						GXmlElement* _tmp171_;
						GMemoryOutputStream* _tmp172_;
						GMemoryOutputStream* _tmp173_;
						GXmlElement* _tmp174_;
						GXmlElement* _tmp175_;
						GXmlDomNode* _tmp176_;
						GXmlDomNode* _tmp177_;
						GXmlCollection* _tmp178_;
						GXmlElement* _tmp179_;
						_tmp162_ = col;
						_tmp163_ = gxml_collection_get_items_type (_tmp162_);
						_tmp164_ = _tmp163_;
						_tmp165_ = gxml_stream_reader_get_document (self);
						_tmp166_ = _tmp165_;
						_tmp167_ = g_object_new (_tmp164_, "owner-document", _tmp166_, NULL);
						_tmp168_ = G_IS_INITIALLY_UNOWNED (_tmp167_) ? g_object_ref_sink (_tmp167_) : _tmp167_;
						_tmp169_ = GXML_IS_ELEMENT (_tmp168_) ? ((GXmlElement*) _tmp168_) : NULL;
						if (_tmp169_ == NULL) {
							_g_object_unref0 (_tmp168_);
						}
						cobj = _tmp169_;
						_tmp170_ = cobj;
						_tmp171_ = ce;
						_tmp172_ = gxml_element_get_read_buffer (_tmp171_);
						_tmp173_ = _tmp172_;
						gxml_element_set_read_buffer (_tmp170_, _tmp173_);
						_tmp174_ = e;
						_tmp175_ = cobj;
						_tmp176_ = gxml_dom_node_append_child ((GXmlDomNode*) _tmp174_, (GXmlDomNode*) _tmp175_, &_inner_error0_);
						_tmp177_ = _tmp176_;
						_g_object_unref0 (_tmp177_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							g_propagate_error (error, _inner_error0_);
							_g_object_unref0 (cobj);
							_g_object_unref0 (col);
							_g_object_unref0 (ce);
							_g_object_unref0 (name_buf);
							_g_object_unref0 (oname_buf);
							_g_object_unref0 (dbuf);
							_g_object_unref0 (buffer);
							_g_object_unref0 (e);
							return NULL;
						}
						_tmp178_ = col;
						_tmp179_ = cobj;
						gxml_collection_append (_tmp178_, (GXmlDomElement*) _tmp179_, &_inner_error0_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							g_propagate_error (error, _inner_error0_);
							_g_object_unref0 (cobj);
							_g_object_unref0 (col);
							_g_object_unref0 (ce);
							_g_object_unref0 (name_buf);
							_g_object_unref0 (oname_buf);
							_g_object_unref0 (dbuf);
							_g_object_unref0 (buffer);
							_g_object_unref0 (e);
							return NULL;
						}
						_g_object_unref0 (cobj);
					} else {
						GXmlElement* _tmp180_;
						GList* _tmp181_;
						GXmlElement* _tmp216_;
						GXmlElement* _tmp217_;
						GXmlDomNode* _tmp218_;
						GXmlDomNode* _tmp219_;
						_tmp180_ = e;
						_tmp181_ = gxml_object_get_property_element_list (G_TYPE_CHECK_INSTANCE_CAST (_tmp180_, GXML_TYPE_OBJECT, GXmlObject));
						{
							GList* pspec_collection = NULL;
							GList* pspec_it = NULL;
							pspec_collection = _tmp181_;
							for (pspec_it = pspec_collection; pspec_it != NULL; pspec_it = pspec_it->next) {
								GParamSpec* _tmp182_;
								GParamSpec* pspec = NULL;
								_tmp182_ = _g_param_spec_ref0 ((GParamSpec*) pspec_it->data);
								pspec = _tmp182_;
								{
									GParamSpec* _tmp183_;
									GXmlElement* obj = NULL;
									GParamSpec* _tmp184_;
									GXmlDomDocument* _tmp185_;
									GXmlDomDocument* _tmp186_;
									GObject* _tmp187_;
									GObject* _tmp188_;
									GXmlElement* _tmp189_;
									GXmlElement* _tmp190_;
									gchar* _tmp191_;
									gchar* _tmp192_;
									gchar* _tmp193_;
									gchar* _tmp194_;
									gchar* _tmp195_;
									GXmlElement* _tmp196_;
									gchar* _tmp197_;
									gchar* _tmp198_;
									gchar* _tmp199_;
									gchar* _tmp200_;
									gchar* _tmp201_;
									gboolean _tmp202_;
									_tmp183_ = pspec;
									if (g_type_is_a (_tmp183_->value_type, GXML_TYPE_COLLECTION)) {
										_g_param_spec_unref0 (pspec);
										continue;
									}
									_tmp184_ = pspec;
									_tmp185_ = gxml_stream_reader_get_document (self);
									_tmp186_ = _tmp185_;
									_tmp187_ = g_object_new (_tmp184_->value_type, "owner-document", _tmp186_, NULL);
									_tmp188_ = G_IS_INITIALLY_UNOWNED (_tmp187_) ? g_object_ref_sink (_tmp187_) : _tmp187_;
									_tmp189_ = GXML_IS_ELEMENT (_tmp188_) ? ((GXmlElement*) _tmp188_) : NULL;
									if (_tmp189_ == NULL) {
										_g_object_unref0 (_tmp188_);
									}
									obj = _tmp189_;
									_tmp190_ = obj;
									_tmp191_ = gxml_dom_element_get_local_name ((GXmlDomElement*) _tmp190_);
									_tmp192_ = _tmp191_;
									_tmp193_ = _tmp192_;
									_tmp194_ = g_utf8_strdown (_tmp193_, (gssize) -1);
									_tmp195_ = _tmp194_;
									_tmp196_ = ce;
									_tmp197_ = gxml_dom_element_get_local_name ((GXmlDomElement*) _tmp196_);
									_tmp198_ = _tmp197_;
									_tmp199_ = _tmp198_;
									_tmp200_ = g_utf8_strdown (_tmp199_, (gssize) -1);
									_tmp201_ = _tmp200_;
									_tmp202_ = g_strcmp0 (_tmp195_, _tmp201_) == 0;
									_g_free0 (_tmp201_);
									_g_free0 (_tmp199_);
									_g_free0 (_tmp195_);
									_g_free0 (_tmp193_);
									if (_tmp202_) {
										GValue v = {0};
										GParamSpec* _tmp203_;
										GValue _tmp204_ = {0};
										GXmlElement* _tmp205_;
										GXmlElement* _tmp206_;
										GParamSpec* _tmp207_;
										const gchar* _tmp208_;
										GValue _tmp209_;
										GXmlElement* _tmp210_;
										GXmlElement* _tmp211_;
										GMemoryOutputStream* _tmp212_;
										GMemoryOutputStream* _tmp213_;
										GXmlElement* _tmp214_;
										GXmlElement* _tmp215_;
										_tmp203_ = pspec;
										g_value_init (&_tmp204_, _tmp203_->value_type);
										v = _tmp204_;
										_tmp205_ = obj;
										g_value_set_object (&v, (GObject*) _tmp205_);
										_tmp206_ = e;
										_tmp207_ = pspec;
										_tmp208_ = _tmp207_->name;
										_tmp209_ = v;
										g_object_set_property ((GObject*) _tmp206_, _tmp208_, &_tmp209_);
										_tmp210_ = obj;
										_tmp211_ = ce;
										_tmp212_ = gxml_element_get_read_buffer (_tmp211_);
										_tmp213_ = _tmp212_;
										gxml_element_set_read_buffer (_tmp210_, _tmp213_);
										_tmp214_ = obj;
										_tmp215_ = _g_object_ref0 (_tmp214_);
										_g_object_unref0 (ce);
										ce = _tmp215_;
										G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
									}
									_g_object_unref0 (obj);
									_g_param_spec_unref0 (pspec);
								}
							}
							(pspec_collection == NULL) ? NULL : (pspec_collection = (_g_list_free__g_param_spec_unref0_ (pspec_collection), NULL));
						}
						_tmp216_ = e;
						_tmp217_ = ce;
						_tmp218_ = gxml_dom_node_append_child ((GXmlDomNode*) _tmp216_, (GXmlDomNode*) _tmp217_, &_inner_error0_);
						_tmp219_ = _tmp218_;
						_g_object_unref0 (_tmp219_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							g_propagate_error (error, _inner_error0_);
							_g_object_unref0 (col);
							_g_object_unref0 (ce);
							_g_object_unref0 (name_buf);
							_g_object_unref0 (oname_buf);
							_g_object_unref0 (dbuf);
							_g_object_unref0 (buffer);
							_g_object_unref0 (e);
							return NULL;
						}
					}
					_g_object_unref0 (col);
					_g_object_unref0 (ce);
				} else {
					GDataOutputStream* _tmp220_;
					GCancellable* _tmp221_;
					GDataOutputStream* _tmp222_;
					GCancellable* _tmp223_;
					_tmp220_ = dbuf;
					_tmp221_ = self->priv->_cancellable;
					g_data_output_stream_put_byte (_tmp220_, (guint8) '<', _tmp221_, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						g_propagate_error (error, _inner_error0_);
						_g_object_unref0 (name_buf);
						_g_object_unref0 (oname_buf);
						_g_object_unref0 (dbuf);
						_g_object_unref0 (buffer);
						_g_object_unref0 (e);
						return NULL;
					}
					_tmp222_ = dbuf;
					_tmp223_ = self->priv->_cancellable;
					g_data_output_stream_put_byte (_tmp222_, gxml_stream_reader_cur_byte (self), _tmp223_, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						g_propagate_error (error, _inner_error0_);
						_g_object_unref0 (name_buf);
						_g_object_unref0 (oname_buf);
						_g_object_unref0 (dbuf);
						_g_object_unref0 (buffer);
						_g_object_unref0 (e);
						return NULL;
					}
				}
			}
		} else {
			GDataOutputStream* _tmp224_;
			GCancellable* _tmp225_;
			_tmp224_ = dbuf;
			_tmp225_ = self->priv->_cancellable;
			g_data_output_stream_put_byte (_tmp224_, gxml_stream_reader_cur_byte (self), _tmp225_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (name_buf);
				_g_object_unref0 (oname_buf);
				_g_object_unref0 (dbuf);
				_g_object_unref0 (buffer);
				_g_object_unref0 (e);
				return NULL;
			}
		}
	}
	result = e;
	_g_object_unref0 (name_buf);
	_g_object_unref0 (oname_buf);
	_g_object_unref0 (dbuf);
	_g_object_unref0 (buffer);
	return result;
}

static void
gxml_stream_reader_parse_xml_dec (GXmlStreamReader* self,
                                  GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		if (!(gxml_stream_reader_cur_char (self) != '>')) {
			break;
		}
		_tmp0_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			return;
		}
		if (!_tmp0_) {
			return;
		}
	}
	gxml_stream_reader_read_byte (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
}

static void
gxml_stream_reader_parse_comment_dec (GXmlStreamReader* self,
                                      GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GString* comment = NULL;
	GString* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GXmlDomComment* c = NULL;
	GXmlDomDocument* _tmp13_;
	GXmlDomDocument* _tmp14_;
	GString* _tmp15_;
	const gchar* _tmp16_;
	GXmlDomComment* _tmp17_;
	GXmlDomDocument* _tmp18_;
	GXmlDomDocument* _tmp19_;
	GXmlDomComment* _tmp20_;
	GXmlDomNode* _tmp21_;
	GXmlDomNode* _tmp22_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
	if (!_tmp0_) {
		GError* _tmp1_;
		_tmp1_ = g_error_new_literal (GXML_STREAM_READER_ERROR, GXML_STREAM_READER_ERROR_INVALID_DOCUMENT_ERROR, _ ("Invalid comment declaration"));
		_inner_error0_ = _tmp1_;
		g_propagate_error (error, _inner_error0_);
		return;
	}
	if (gxml_stream_reader_cur_char (self) != '-') {
		GError* _tmp2_;
		_tmp2_ = g_error_new_literal (GXML_STREAM_READER_ERROR, GXML_STREAM_READER_ERROR_INVALID_DOCUMENT_ERROR, _ ("Invalid comment declaration"));
		_inner_error0_ = _tmp2_;
		g_propagate_error (error, _inner_error0_);
		return;
	}
	_tmp3_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
	if (!_tmp3_) {
		return;
	}
	if (gxml_stream_reader_cur_char (self) != '-') {
		GError* _tmp4_;
		_tmp4_ = g_error_new_literal (GXML_STREAM_READER_ERROR, GXML_STREAM_READER_ERROR_INVALID_DOCUMENT_ERROR, _ ("Invalid comment declaration"));
		_inner_error0_ = _tmp4_;
		g_propagate_error (error, _inner_error0_);
		return;
	}
	_tmp5_ = g_string_new ("");
	comment = _tmp5_;
	_tmp6_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_string_free0 (comment);
		return;
	}
	if (!_tmp6_) {
		_g_string_free0 (comment);
		return;
	}
	while (TRUE) {
		GString* _tmp7_;
		gboolean _tmp8_ = FALSE;
		if (!(gxml_stream_reader_cur_char (self) != '>')) {
			break;
		}
		_tmp7_ = comment;
		g_string_append_c (_tmp7_, gxml_stream_reader_cur_char (self));
		_tmp8_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_string_free0 (comment);
			return;
		}
		if (!_tmp8_) {
			break;
		}
		if (gxml_stream_reader_cur_char (self) == '-') {
			gboolean _tmp9_ = FALSE;
			GString* _tmp12_;
			_tmp9_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_string_free0 (comment);
				return;
			}
			if (!_tmp9_) {
				break;
			}
			if (gxml_stream_reader_cur_char (self) == '-') {
				gboolean _tmp10_ = FALSE;
				_tmp10_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_string_free0 (comment);
					return;
				}
				if (!_tmp10_) {
					break;
				}
				if (gxml_stream_reader_cur_char (self) == '-') {
					GError* _tmp11_;
					_tmp11_ = g_error_new_literal (GXML_STREAM_READER_ERROR, GXML_STREAM_READER_ERROR_INVALID_DOCUMENT_ERROR, _ ("Invalid comment declaration"));
					_inner_error0_ = _tmp11_;
					g_propagate_error (error, _inner_error0_);
					_g_string_free0 (comment);
					return;
				} else {
					if (gxml_stream_reader_cur_char (self) == '>') {
						break;
					}
				}
			}
			_tmp12_ = comment;
			g_string_append_c (_tmp12_, '-');
		}
	}
	_tmp13_ = gxml_stream_reader_get_document (self);
	_tmp14_ = _tmp13_;
	_tmp15_ = comment;
	_tmp16_ = _tmp15_->str;
	_tmp17_ = gxml_dom_document_create_comment (_tmp14_, _tmp16_, &_inner_error0_);
	c = _tmp17_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_string_free0 (comment);
		return;
	}
	_tmp18_ = gxml_stream_reader_get_document (self);
	_tmp19_ = _tmp18_;
	_tmp20_ = c;
	_tmp21_ = gxml_dom_node_append_child ((GXmlDomNode*) _tmp19_, (GXmlDomNode*) _tmp20_, &_inner_error0_);
	_tmp22_ = _tmp21_;
	_g_object_unref0 (_tmp22_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (c);
		_g_string_free0 (comment);
		return;
	}
	_g_object_unref0 (c);
	_g_string_free0 (comment);
}

static void
gxml_stream_reader_parse_pi_dec (GXmlStreamReader* self,
                                 GError** error)
{
	gboolean _tmp0_ = FALSE;
	GString* str = NULL;
	GString* _tmp1_;
	gchar* target = NULL;
	GString* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GString* _tmp8_;
	GXmlDomProcessingInstruction* pi = NULL;
	GXmlDomDocument* _tmp11_;
	GXmlDomDocument* _tmp12_;
	const gchar* _tmp13_;
	GString* _tmp14_;
	const gchar* _tmp15_;
	GXmlDomProcessingInstruction* _tmp16_;
	GXmlDomDocument* _tmp17_;
	GXmlDomDocument* _tmp18_;
	GXmlDomProcessingInstruction* _tmp19_;
	GXmlDomNode* _tmp20_;
	GXmlDomNode* _tmp21_;
	gboolean _tmp22_ = FALSE;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = g_string_new ("");
	str = _tmp1_;
	while (TRUE) {
		GString* _tmp3_;
		gboolean _tmp4_ = FALSE;
		if (!(!gxml_stream_reader_is_space (self, gxml_stream_reader_cur_char (self)))) {
			break;
		}
		if (gxml_stream_reader_cur_char (self) == '?') {
			GError* _tmp2_;
			_tmp2_ = g_error_new_literal (GXML_STREAM_READER_ERROR, GXML_STREAM_READER_ERROR_INVALID_DOCUMENT_ERROR, _ ("Invalid Processing Instruction's target declaration"));
			_inner_error0_ = _tmp2_;
			g_propagate_error (error, _inner_error0_);
			_g_string_free0 (str);
			return;
		}
		_tmp3_ = str;
		g_string_append_c (_tmp3_, gxml_stream_reader_cur_char (self));
		_tmp4_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_string_free0 (str);
			return;
		}
		if (!_tmp4_) {
			_g_string_free0 (str);
			return;
		}
	}
	_tmp5_ = str;
	_tmp6_ = _tmp5_->str;
	_tmp7_ = g_strdup (_tmp6_);
	target = _tmp7_;
	_tmp8_ = str;
	g_string_assign (_tmp8_, "");
	while (TRUE) {
		GString* _tmp9_;
		gboolean _tmp10_ = FALSE;
		if (!(gxml_stream_reader_cur_char (self) != '?')) {
			break;
		}
		_tmp9_ = str;
		g_string_append_c (_tmp9_, gxml_stream_reader_cur_char (self));
		_tmp10_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (target);
			_g_string_free0 (str);
			return;
		}
		if (!_tmp10_) {
			_g_free0 (target);
			_g_string_free0 (str);
			return;
		}
	}
	_tmp11_ = gxml_stream_reader_get_document (self);
	_tmp12_ = _tmp11_;
	_tmp13_ = target;
	_tmp14_ = str;
	_tmp15_ = _tmp14_->str;
	_tmp16_ = gxml_dom_document_create_processing_instruction (_tmp12_, _tmp13_, _tmp15_, &_inner_error0_);
	pi = _tmp16_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (target);
		_g_string_free0 (str);
		return;
	}
	_tmp17_ = gxml_stream_reader_get_document (self);
	_tmp18_ = _tmp17_;
	_tmp19_ = pi;
	_tmp20_ = gxml_dom_node_append_child ((GXmlDomNode*) _tmp18_, (GXmlDomNode*) _tmp19_, &_inner_error0_);
	_tmp21_ = _tmp20_;
	_g_object_unref0 (_tmp21_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (pi);
		_g_free0 (target);
		_g_string_free0 (str);
		return;
	}
	_tmp22_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (pi);
		_g_free0 (target);
		_g_string_free0 (str);
		return;
	}
	if (!_tmp22_) {
		_g_object_unref0 (pi);
		_g_free0 (target);
		_g_string_free0 (str);
		return;
	}
	if (gxml_stream_reader_cur_char (self) != '>') {
		GError* _tmp23_;
		_tmp23_ = g_error_new_literal (GXML_STREAM_READER_ERROR, GXML_STREAM_READER_ERROR_INVALID_DOCUMENT_ERROR, _ ("Invalid Processing Instruction's close declaration"));
		_inner_error0_ = _tmp23_;
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (pi);
		_g_free0 (target);
		_g_string_free0 (str);
		return;
	}
	_g_object_unref0 (pi);
	_g_free0 (target);
	_g_string_free0 (str);
}

static void
gxml_stream_reader_read_text_node (GXmlStreamReader* self,
                                   GError** error)
{
	GString* text = NULL;
	GString* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GXmlDomText* t = NULL;
	GXmlDomDocument* _tmp3_;
	GXmlDomDocument* _tmp4_;
	GString* _tmp5_;
	const gchar* _tmp6_;
	GXmlDomText* _tmp7_;
	GXmlDomDocument* _tmp8_;
	GXmlDomDocument* _tmp9_;
	GXmlDomText* _tmp10_;
	GXmlDomNode* _tmp11_;
	GXmlDomNode* _tmp12_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_string_new ("");
	text = _tmp0_;
	_tmp1_ = gxml_stream_reader_read_byte (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_string_free0 (text);
		return;
	}
	if (!_tmp1_) {
		_g_string_free0 (text);
		return;
	}
	if (!gxml_stream_reader_is_space (self, gxml_stream_reader_cur_char (self))) {
		_g_string_free0 (text);
		return;
	}
	while (TRUE) {
		GString* _tmp2_;
		if (!gxml_stream_reader_is_space (self, gxml_stream_reader_cur_char (self))) {
			break;
		}
		_tmp2_ = text;
		g_string_append_c (_tmp2_, gxml_stream_reader_cur_char (self));
		{
			gxml_stream_reader_read_byte (self, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			g_clear_error (&_inner_error0_);
			_g_string_free0 (text);
			return;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_string_free0 (text);
			return;
		}
	}
	_tmp3_ = gxml_stream_reader_get_document (self);
	_tmp4_ = _tmp3_;
	_tmp5_ = text;
	_tmp6_ = _tmp5_->str;
	_tmp7_ = gxml_dom_document_create_text_node (_tmp4_, _tmp6_, &_inner_error0_);
	t = _tmp7_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_string_free0 (text);
		return;
	}
	_tmp8_ = gxml_stream_reader_get_document (self);
	_tmp9_ = _tmp8_;
	_tmp10_ = t;
	_tmp11_ = gxml_dom_node_append_child ((GXmlDomNode*) _tmp9_, (GXmlDomNode*) _tmp10_, &_inner_error0_);
	_tmp12_ = _tmp11_;
	_g_object_unref0 (_tmp12_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (t);
		_g_string_free0 (text);
		return;
	}
	_g_object_unref0 (t);
	_g_string_free0 (text);
}

static gboolean
gxml_stream_reader_is_space (GXmlStreamReader* self,
                             gchar c)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (((gint) c) == 0x20) {
		_tmp4_ = TRUE;
	} else {
		_tmp4_ = ((gint) c) == 0x9;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		_tmp3_ = ((gint) c) == 0xA;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = c == ' ';
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = c == '\t';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = c == '\n';
	}
	result = _tmp0_;
	return result;
}

static void
gxml_stream_reader_class_init (GXmlStreamReaderClass * klass,
                               gpointer klass_data)
{
	gxml_stream_reader_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GXmlStreamReader_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_stream_reader_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gxml_stream_reader_set_property;
	G_OBJECT_CLASS (klass)->finalize = gxml_stream_reader_finalize;
	/**
	   * The stream where data is read from
	   * to parse and fill {@link GXml.Element.read_buffer}
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_STREAM_READER_STREAM_PROPERTY, gxml_stream_reader_properties[GXML_STREAM_READER_STREAM_PROPERTY] = g_param_spec_object ("stream", "stream", "stream", g_data_input_stream_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	   * Use it to cancel the parse and fill process
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_STREAM_READER_CANCELLABLE_PROPERTY, gxml_stream_reader_properties[GXML_STREAM_READER_CANCELLABLE_PROPERTY] = g_param_spec_object ("cancellable", "cancellable", "cancellable", g_cancellable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	   * Current {@link DomDocument} used to read to.
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_STREAM_READER_DOCUMENT_PROPERTY, gxml_stream_reader_properties[GXML_STREAM_READER_DOCUMENT_PROPERTY] = g_param_spec_object ("document", "document", "document", GXML_TYPE_DOM_DOCUMENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
gxml_stream_reader_instance_init (GXmlStreamReader * self,
                                  gpointer klass)
{
	guint8* _tmp0_;
	GeeHashMap* _tmp1_;
	self->priv = gxml_stream_reader_get_instance_private (self);
	_tmp0_ = g_new0 (guint8, 2);
	self->priv->buf = _tmp0_;
	self->priv->buf_length1 = 2;
	self->priv->_buf_size_ = self->priv->buf_length1;
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GXML_TYPE_COLLECTION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->root_collections = _tmp1_;
	self->priv->_stream = NULL;
	self->priv->_document = NULL;
	self->priv->start = TRUE;
}

static void
gxml_stream_reader_finalize (GObject * obj)
{
	GXmlStreamReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_STREAM_READER, GXmlStreamReader);
	self->priv->buf = (g_free (self->priv->buf), NULL);
	_g_object_unref0 (self->priv->root_collections);
	_g_object_unref0 (self->priv->_stream);
	_g_object_unref0 (self->priv->_document);
	_g_object_unref0 (self->priv->_cancellable);
	G_OBJECT_CLASS (gxml_stream_reader_parent_class)->finalize (obj);
}

/**
 * Parser using a on the fly-post-parsing technique
 *
 * This parser takes or creates a {@link Document}, search
 * and adds the root XML element as a {@link Element};
 * then search and add all children {@link Element}.
 *
 * The root element is added without any attribute and
 * without any content or children; the same hapends with all
 * children.
 *
 * After call {@link read} or {@link read_document},
 * Root's and its children's content and its attributes
 * are stored as a string in a {@link GLib.MemoryOutputStream}
 * object at {@link GXml.Element.read_buffer}.
 *
 * If you want all attributes and children's children,
 * you should call {@link GXml.Element.parse_buffer},
 * which execute children's {@link GXml.Element.parse_buffer}
 * all asyncronically.
 */
static GType
gxml_stream_reader_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlStreamReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_stream_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlStreamReader), 0, (GInstanceInitFunc) gxml_stream_reader_instance_init, NULL };
	GType gxml_stream_reader_type_id;
	gxml_stream_reader_type_id = g_type_register_static (G_TYPE_OBJECT, "GXmlStreamReader", &g_define_type_info, 0);
	GXmlStreamReader_private_offset = g_type_add_instance_private (gxml_stream_reader_type_id, sizeof (GXmlStreamReaderPrivate));
	return gxml_stream_reader_type_id;
}

GType
gxml_stream_reader_get_type (void)
{
	static volatile gsize gxml_stream_reader_type_id__once = 0;
	if (g_once_init_enter (&gxml_stream_reader_type_id__once)) {
		GType gxml_stream_reader_type_id;
		gxml_stream_reader_type_id = gxml_stream_reader_get_type_once ();
		g_once_init_leave (&gxml_stream_reader_type_id__once, gxml_stream_reader_type_id);
	}
	return gxml_stream_reader_type_id__once;
}

static void
_vala_gxml_stream_reader_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	GXmlStreamReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_STREAM_READER, GXmlStreamReader);
	switch (property_id) {
		case GXML_STREAM_READER_STREAM_PROPERTY:
		g_value_set_object (value, gxml_stream_reader_get_stream (self));
		break;
		case GXML_STREAM_READER_CANCELLABLE_PROPERTY:
		g_value_set_object (value, gxml_stream_reader_get_cancellable (self));
		break;
		case GXML_STREAM_READER_DOCUMENT_PROPERTY:
		g_value_set_object (value, gxml_stream_reader_get_document (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gxml_stream_reader_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	GXmlStreamReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_STREAM_READER, GXmlStreamReader);
	switch (property_id) {
		case GXML_STREAM_READER_CANCELLABLE_PROPERTY:
		gxml_stream_reader_set_cancellable (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

